DECLARE SUB Pause ()
DECLARE SUB Reseten ()
DECLARE FUNCTION Bit4% (a%, b%, c%, d%)
DECLARE FUNCTION Bit8% (a%, b%, c%, d%, e%, f%, g%, h%)
DECLARE FUNCTION Multiplikator% (a%, b%, c%, d%, e%, f%, g%, h%)

'---------------------------------------------------------------------------
'       Programm zum Auslesen einer Telefonkarte
'---------------------------------------------------------------------------
'Bei dem Programm muss eventuel noch (je nach PC) die Adresse der Schnittstelle
'von &H378/9 auf &H278/9 bzw. &H3BC/D umgestellt werden (der zweite Wert steht
'jeweils fr die Adresse, ber die man einlesen kann).
'Auch muss je nach Schaltung der Wert fr die Schnittstelle umgendert werden.
'Bei diesem Programm habe ich fr CLK-Ausgang den Wert 1 (= Data-Line 1 der
'SChnittstelle) gewhlt. Fr Reset den Wert 2 und fr die I/O-Leitung den
'ERROR-Pin der Schnittstelle.

DIM Bit%(127)                       'Array zum einlesen der Bits
Standart% = INP(&H379)                  'Null-Wert der Schnittstelle einlesen

CLS
PRINT "Bitte die Karte in das Gert schieben und Taste drcken."
DO
LOOP UNTIL INKEY$ <> ""

Reseten                                 'Den Chip reseten

FOR einlesen% = 0 TO 127                'Jetzt die 128 Bit auslesen
        OUT &H378, 1
        Wert% = INP(&H379)
        IF Wert% <> Standart% THEN      'Wenn ungleich dem Null-Wert, dann liegt ein High an der Schnittstelle
                Bit%(einlesen%) = 1     'an also auf 1 setzen
        ELSE                            'Wenn gleich Null-Wert, dann Low -> 0
                Bit%(einlesen%) = 0
        END IF
        Pause
        OUT &H378, 0                    'Clock-Zyklus beenden
NEXT einlesen%

FOR ausgeben% = 0 TO 127
        spalte% = spalte% + 1
        IF spalte% > 79 THEN spalte% = 1: zeile% = zeile% + 1
        LOCATE spalte%, zeile%
        PRINT Bit%(ausgeben%)           'Die Bits auf dem Monitor anzeigen
NEXT ausgeben%


'So jetzt drfte bereits der in der Telefonkarte gespeicherte Binrcode
'ausgelesen sein. Jetzt kommen einige Functions, die das verarbeiten der Bits
'erleichtern:
'       Bit4% (a%, b%, c%, d%)
'       Gibt den Dezimalwert der vier Bits wieder
'
'       Bit8% (a%, b%, c%, d%, e%, f%, g%, h%)
'       Gibt den Dezimalwert der acht Bits wieder
'
'       Multiplikator% (a%, b%, c%, d%, e%, f%, g%, h%)
'       Gibt den Wert fr die Multiplikatoren wieder
'
'Zuerst wollen wir mal den Kaufbetrag der Karte anzeigen

a% = Bit%(32)
b% = Bit%(33)
c% = Bit%(34)
d% = Bit%(35)
Dezimal% = Bit4%(a%, b%, c%, d%)

IF Dezimal% = 0 THEN Kaufwert$ = "1,50 DM."
IF Dezimal% = 1 THEN Kaufwert$ = "6,00 DM."
IF Dezimal% = 2 THEN Kaufwert$ = "12,00 DM."
IF Dezimal% = 3 THEN Kaufwert$ = "60,00 DM."

PRINT "Der Kaufpreis betrug "; Kaufwert$

'Jetzt wagen wir uns noch an den Restbetrag

a% = Bit%(64)
b% = Bit%(65)
c% = Bit%(66)
d% = Bit%(67)
e% = Bit%(68)
f% = Bit%(69)
g% = Bit%(70)
h% = Bit%(71)

Multa% = Multiplikator%(a%, b%, c%, d%, e%, f%, g%, h%)

a% = Bit%(72)
b% = Bit%(73)
c% = Bit%(74)
d% = Bit%(75)
e% = Bit%(76)
f% = Bit%(77)
g% = Bit%(78)
h% = Bit%(79)

MultB% = Multiplikator%(a%, b%, c%, d%, e%, f%, g%, h%)

a% = Bit%(80)
b% = Bit%(81)
c% = Bit%(82)
d% = Bit%(83)
e% = Bit%(84)
f% = Bit%(85)
g% = Bit%(86)
h% = Bit%(87)

MultC% = Multiplikator%(a%, b%, c%, d%, e%, f%, g%, h%)

a% = Bit%(88)
b% = Bit%(89)
c% = Bit%(90)
d% = Bit%(91)
e% = Bit%(92)
f% = Bit%(93)
g% = Bit%(94)
h% = Bit%(95)

MultD% = Multiplikator%(a%, b%, c%, d%, e%, f%, g%, h%)

a% = Bit%(96)
b% = Bit%(97)
c% = Bit%(98)
d% = Bit%(99)
e% = Bit%(100)
f% = Bit%(101)
g% = Bit%(102)
h% = Bit%(103)

MultE% = Multiplikator%(a%, b%, c%, d%, e%, f%, g%, h%)

Restwert& = Multa% * 4096 + MultB% * 512 + MultC% * 64 + MultD% * 8 + MultE%

PRINT "Der Restwert betrgt"; Restwert& / 100; " DM."

'Das war jetzt mal das simple Programm. Wer mehr machen will, dem stelle ich
'gerne den Quelltext zu meinem VESA-Programm zur verfgung (nicht kommentiert).
'Ausfhrlichere Informationen und Tabellen zu den Bits werden entweder bald auf
'meiner HP folgen, oder ihr msst selber suchen (bisher hatte ich noch keine
'Lust wieder alles abzuschreiben).

'(C) by MDM 2004

FUNCTION Bit4% (a%, b%, c%, d%)

IF d% = 1 THEN Bit% = Bit% + 8
IF c% = 1 THEN Bit% = Bit% + 4
IF b% = 1 THEN Bit% = Bit% + 2
IF a% = 1 THEN Bit% = Bit% + 1

Bit4% = Bit%

END FUNCTION

FUNCTION Bit8% (a%, b%, c%, d%, e%, f%, g%, h%)

IF h% = 1 THEN Bit% = Bit% + 128
IF g% = 1 THEN Bit% = Bit% + 64
IF f% = 1 THEN Bit% = Bit% + 32
IF e% = 1 THEN Bit% = Bit% + 16
IF d% = 1 THEN Bit% = Bit% + 8
IF c% = 1 THEN Bit% = Bit% + 4
IF b% = 1 THEN Bit% = Bit% + 2
IF a% = 1 THEN Bit% = Bit% + 1

Bit8% = Bit%

END FUNCTION

FUNCTION Multiplikator% (a%, b%, c%, d%, e%, f%, g%, h%)

IF a% = 1 THEN Multi% = Multi% + 1
IF b% = 1 THEN Multi% = Multi% + 1
IF c% = 1 THEN Multi% = Multi% + 1
IF d% = 1 THEN Multi% = Multi% + 1
IF e% = 1 THEN Multi% = Multi% + 1
IF f% = 1 THEN Multi% = Multi% + 1
IF g% = 1 THEN Multi% = Multi% + 1

Multiplikator% = Multi%

END FUNCTION

SUB Pause

        TimeOld! = TIMER
        DO
        LOOP UNTIL TIMER - TimeOld! > .001

END SUB

SUB Reseten

OUT &H378, 2
Pause
OUT &H378, 2 + 1
Pause
OUT &H378, 2

END SUB

